package cokr.xit.fims.levy.service.bean;

import java.util.List;

import javax.annotation.Resource;

import org.springframework.stereotype.Component;

import cokr.xit.foundation.AbstractComponent;
import cokr.xit.foundation.data.DataObject;
import cokr.xit.fims.levy.Levy;
import cokr.xit.fims.levy.LevyQuery;
import cokr.xit.fims.levy.dao.LevyMapper;

/**부과 대장 정보 관리 Bean
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-08-30	JoJH 최초 작성
 * ================================
 * </pre>
 */
@Component("levy01Bean")
public class Levy01Bean extends AbstractComponent {

	/** 부과 대장 정보 DAO */
	@Resource(name = "levyMapper")
	private LevyMapper levyMapper;

	/**지정한 조건에 따라 부과 대장 목록을 조회하여 반환한다.
	 * @param req 부과 대장 조회 조건
	 * @return 부과 대장 목록
	 */
	public List<DataObject> getLevyList(LevyQuery req) {
		return levyMapper.selectLevyList(req);
	}

	/**지정한 조건에 따라 부과 대장 객체들을 반환한다.
	 * @param req 부과 대장 조회 조건
	 * @return 부과 대장 객체 목록
	 */
	public List<DataObject> getLevys(LevyQuery req) {
		return levyMapper.selectLevys(req);
	}

	/**지정한 부과 ID의 부과 대장 객체를 반환한다.<br />
	 * @param req 부과 대장 조회 조건
	 * @return 부과 대장 객체
	 */
	public DataObject getLevyInfo(LevyQuery req) {
		return levyMapper.selectLevyInfo(req);
	}

	/**부과 대장 정보를 등록한다.
	 * @param levy 부과 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean createLevy(Levy levy) {
		return levyMapper.insert(levy);
	}

	/**부과 대장 정보를 수정한다.
	 * @param levy 부과 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean updateLevy(Levy levy) {
		return levyMapper.update(levy);
	}

	/**부과 대장 정보를 삭제한다.
	 * @param levy 부과 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean removeLevy(Levy levy) {
		return levyMapper.delete(levy);
	}

}
